/**

/* Includes ------------------------------------------------------------------*/
#include <stm8l15x.h>
#include <stdlib.h>

#include <delay.h>

#define CS    GPIO_Pin_1 // PB1   
#define ReST  GPIO_Pin_0 // PB0
#define RS    GPIO_Pin_7 // PA7 
#define LCD_D GPIO_Pin_6 // PB5
#define LCD_C	GPIO_Pin_5 // PB6

const unsigned int LCD_InitData_step2[] = {0x4306,0xEE04,0x7F3F,0x4A04,0xEF90,0xFEFE,0xFEFE,0x1B04,0xEE04,0xEF00,0x1B04,0xEE04,0xEF00};
const unsigned int LCD_InitData_step3[] = {0x0000,0xEF90,0x8001,0xE183,0xE2FF,0x7F01,0xEF00,0x4902,0xEFB0,0x0080,
                                           0xEF90,0xEE0C,0xEF00,0x0700,0x0600,0x0504,0x0A00,0x0BAF,0x0800,0x0983,0xEF90};

void ls020_wrcmd16(unsigned int cmd16);
void ls020_wrcmd8(unsigned char cmd);


void main(void)
{
uint8_t i;

  /* PORT INIT */
  GPIO_Init(GPIOB, CS | ReST, GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOA, RS, GPIO_Mode_Out_PP_Low_Fast);
  //GPIO_Init(GPIOB, LCD_D | LCD_C, GPIO_Mode_Out_PP_Low_Fast);
	
  /* SPI INIT*/
  SYSCFG->RMPCR1 = 0x00;//SYSCFG_RMPCR1_SPI1_REMAP; // PB  RESET
  SPI_DeInit(SPI1);
  SPI_Init( SPI1, SPI_FirstBit_MSB, SPI_BaudRatePrescaler_2,
   		SPI_Mode_Master, SPI_CPOL_High, SPI_CPHA_2Edge, 
		SPI_Direction_2Lines_FullDuplex, SPI_NSS_Soft, 0x07);
		SPI_Cmd(SPI1, ENABLE);
							
  /* LCD Display Init*/
  GPIO_SetBits(GPIOB, ReST); //Reset High
  delay_ms(10);
  GPIO_ResetBits(GPIOB, ReST); // Reset Lo
  delay_ms(10);
  GPIO_SetBits(GPIOB, ReST); //Reset High
  delay_ms(10);
  GPIO_ResetBits(GPIOB, CS); //CS Lo
  GPIO_SetBits(GPIOA, RS); //RS High
  ls020_wrcmd16(0xFDFD);
  ls020_wrcmd16(0xFDFD); 
  delay_ms(68);
  i=13;
  while(i--) ls020_wrcmd16(LCD_InitData_step2[i]);
  delay_ms(9);       
  i=21;
  while(i--)  ls020_wrcmd16(LCD_InitData_step3[i]);
  GPIO_SetBits(GPIOB, CS); //CS Hi

/* MAIN PROJECT*/

/* END */

  while (1)
  {	
  	GPIO_ToggleBits(GPIOC, GPIO_Pin_7);
  	delay_ms(1000);
  }
}

void SPI_WriteByte(u8 dat) 
{
  u8 a;
  GPIO_SetBits(GPIOA, RS); //RS High
  GPIO_ResetBits(GPIOB, CS); // select LCD
  SPI1->DR=dat;
  while(!(SPI1->SR & (uint8_t)SPI_FLAG_RXNE)); 
  a=SPI1->DR;
  GPIO_SetBits(GPIOB, CS); // deselect LCD
}

void ls020_wrcmd16(unsigned int cmd16)
{
  SPI_WriteByte(cmd16>>8);
  SPI_WriteByte(cmd16); 
}


#ifdef  USE_FULL_ASSERT

void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif
/**
  * @}
  */


/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/